﻿local addonName, QD = ...; -- gets addon-local variables


----------------------------------------------------------------------------------------------------
-- DEBUG Test functions

--/ Output of all characters, their choosen color, their individual color and their group and groupcolor
function QD.Debug_ColorsChar()
    local nC = 0; for k,v in pairs (QD.vips) do nC = nC + 1; end
    print("QuiDicit colors (characters) ("..nC.."):");
    for k,v in pairs (QD.vips) do
        local name = ""..tostring(k);

        local color = QD.Color_GetChatColor(name);
        local unit = name;
        if ( color and color ~= "" ) then
            unit = "|cFF" .. color .. name .. "|r";
        end

        if(v.color ~= "") then
            name = "|cFF"..v.color..name.."|r ("..v.color..")";
        end
        local group = ""..tostring(v.group);
        if(QD.vigs[group] and QD.vigs[group] ~= "") then
            group = "|cFF"..QD.vigs[group].color..group.."|r ("..QD.vigs[group].color..")";
        end
        if ( group and group == "" ) then
            group = "none";
        end
        print("    "..unit..":   "..tostring(name).." belongs to " .. tostring(group));
    end
end

--/ Output of all groups with their color and amount of characters in it
function QD.Debug_ColorsGroup()
    local nG = 0; for k,v in pairs (QD.vigs) do nG = nG + 1; end
    print("QuiDicit colors (group) ("..nG.."):");
    for k,v in pairs (QD.vigs) do
        local g = ""..tostring(k);
        if(g.color ~= "") then
            g = "|cFF"..v.color..g.."|r ("..v.color..")";
        end
        print("    "..tostring(g));
    end
end

--/ Outputs the color of each characters name
function QD.Debug_PriorityColor()
    local nC = 0; for k,v in pairs (QD.vigs) do nC = nC + 1; end
    print("QuiDicit choosen colors (character) ("..nC.."):");
    for k,v in pairs (QD.vips) do
        local c = ""..tostring(k);
        local color = QD.Color_GetChatColor(c);
        c = "|cFF" .. color .. c .. "|r (" .. v.color .. ")";
        print("    "..tostring(c));
    end
end


----------------------------------------------------------------------------------------------------
-- DEBUG Slash commands

SlashCmdList['QUIDICIT_DEBUG_SLASHCMD'] = function( msg, ... )
    local command, args = msg:match("^(%S*)%s*(.-)$");

    if ( command == "colors" ) then
        -- prints the color settings of characters and groups
        QD.Debug_ColorsChar();
        QD.Debug_ColorsGroup();

    elseif ( command == "colorsprio" ) then
        -- prints the chosen color of each character
        QD.Debug_PriorityColor();

    else
        -- shows possible arguments for slash command
        QD.printInfo("QuiDicit Debug commands:");
        QD.printInfo("    /qddebug colors shows all colored names and groups");
        QD.printInfo("    /qddebug colorsprio shows names with their used color");

    end
end
SLASH_QUIDICIT_DEBUG_SLASHCMD1 = '/qddebug';